#pragma once

#include <memory>
#include <vector>
#include <unordered_map>
#include <string>

class AbstractFace
{
public:
    AbstractFace(unsigned id=0);

    virtual ~AbstractFace() = default;

    virtual std::vector<unsigned> getNodeIds() const = 0;

    void addVectorAttribute(const std::string& tag, const std::vector<double>& values);

    std::vector<double> getVectorAttribute(const std::string& tag) const;

protected:
    unsigned mId{0};
    std::unordered_map<std::string, std::vector<double> > mVectorAttributes;
};
