#pragma once

#include "AbstractMesh.h"

#include <string>
#include <unordered_map>

class Edge;
using EdgePtr = std::unique_ptr<Edge>;
using VecEdges = std::vector<EdgePtr>;

class LineMesh : public AbstractMesh
{
public:
    LineMesh() = default;

    ~LineMesh();

    void populate(VecNodes& nodes, VecEdges& edges);

    std::vector<unsigned> getEdgeNodeIds() const;

    MeshType getType() const override
    {
        return MeshType::LINE;
    }

private:
    VecEdges mEdges;
};
