#pragma once

#include "Point.h"

#include <unordered_map>
#include <string>
#include <vector>


class Node
{
public:
    Node(const Point& p, unsigned index = 0);

    static std::unique_ptr<Node> Create(const Point& p, unsigned index = 0);

    ~Node();

    unsigned getIndex() const;

    void updateIndex(unsigned index);

    const Point& getPoint() const
    {
        return mPoint;
    }

    void addVectorAttribute(const std::string& tag, const std::vector<double>& values);

    std::vector<double> getVectorAttribute(const std::string& tag) const;

    void scale(double x, double y)
    {
        mPoint.scale(x, y);
    }

    void translate(double x, double y, double z = 0.0)
    {
        mPoint.translate(x, y, z);
    }

private:
    std::unordered_map<std::string, std::vector<double> > mVectorAttributes;
    unsigned mIndex{0};
    Point mPoint;
};
