#include "TriFace.h"

#include "Edge.h"

TriFace::TriFace(Edge* edge0, Edge* edge1, Edge* edge2, unsigned id)
    :  AbstractFace(id),
        mEdge0(edge0),
        mEdge1(edge1),
        mEdge2(edge2)
{

}

std::unique_ptr<TriFace> TriFace::Create(Edge* edge0, Edge* edge1, Edge* edge2, unsigned id)
{
    return std::make_unique<TriFace>(edge0, edge1, edge2, id);
}

TriFace::~TriFace()
{

}

std::vector<unsigned> TriFace::getNodeIds() const
{
    return {mEdge0->getNode0Id(), mEdge0->getNode1Id(), mEdge1->getNode1Id()};
}
